function [Z C E ] = generate_category_ibp( N , params );

% initialise
category_count = 0;
C = [];
E = [];
Z = [];

% customers enter
for i = 1:N
    featCount = size( C , 2 );
    
    % customers choose categories a la IBP
    prC = sum( C , 1 ) / i;
    for k = 1:size( C , 2 )
        if rand < prC( k )
            C( i , k ) = 1;
        else
            C( i , k ) = 0;
        end
    end
    newC = poissrnd( params.alpha_c / i );
    C( i , (end+1):(end+newC) ) = 1;
    
    % if we have created new categories, link them to feats
    for k = 1:newC
        category_count = category_count + 1;
         prE = sum( E , 1 ) / category_count;
        for j = 1:size( E , 2 )
            if rand < prE( j )
                E( category_count , j ) = 1;
            else
                E( category_count , j ) = 0;
            end
        end
        newE = poissrnd( params.alpha_e / category_count );
        E( category_count , (end+1):(end+newE) ) = 1;
    end
    
    % turn on feats
    prZ = 1 - params.q.^( C( i , : ) * E );
    for k = 1:size( E , 2 )
        if rand < prZ( k )
            Z( i , k ) = 1;
        else
            Z( i , k ) = 0;
        end
    end
    
end