function [Z combo_assign_set combo_value_set] = generate_dp_ibp( N , param_set );
% function [Z combo_assign_set combo_value_set] = generate_dp_ibp( N , param_set );

% initialise
combo_count = 0;
combo_value_set = [];
combo_assign_set = [];
Z = [];

% customers enter
for i = 1:N
    featCount = size( Z , 2 );
    
    % customers decide on a combo a la DP
    prC = [ sum( combo_assign_set , 1 ) param_set.alpha_c ];
    prC = prC  / ( i + param_set.alpha_c );
    c = sampleMultinomial( prC );
    
    % add their combo
    if c > combo_count

        % add a new combo to the combo_value_set
        combo_count = combo_count + 1;
        prC = sum( combo_value_set , 1 ) / combo_count;
        for k = 1:size( combo_value_set , 2 )
            if rand < prC( k )
                combo_value_set( combo_count , k ) = 1;
            else
                combo_value_set( combo_count , k ) = 0;
            end
        end
        newC = poissrnd( param_set.alpha_e / i );
        combo_value_set( combo_count , (end+1):(end+newC) ) = 1;
    end
    newFeatCount = size( combo_value_set , 2 );
    
    % add the combo to the Z
    Z = [ Z zeros( (i-1) , ( newFeatCount - featCount ) ) ]; 
    Z( i , : ) = combo_value_set( c , : );
    combo_assign_set( i , c ) = 1;
    
end
