function [ m a ] = extend_m( m , a , k_new , param_set )
% function [ m a ] = extend_m( m , a , k_new , param_set )
original_feature_count = size( m , 2 );

% first extend the m
for k = 1:k_new
    p_k = sum( m , 1 ) / size( m , 1 );
    m( end+1 , : ) = double( rand( 1 , size( m , 2 ) ) < p_k );
    switch param_set.model_type
        case { 'lg' , 'exp' },
            f_new = poissrnd( param_set.alpha_e / size( m , 1 ) );
            m( end , (end+1):(end+f_new) ) = 1;
    end
end

% then sample additional parts of a
if size( m , 2 ) > original_feature_count
    dim_count = size( a , 2 );
    switch param_set.model_type
        case 'lg', a = [ a ; param_set.mean_f + param_set.sigma_f * randn( f_new , dim_count ) ];
        case 'exp', a = [ a ; random( 'exp' , param_set.lambda , [ f_new , dim_count ] ) ];
    end
end