function ll = lpdfDP( z , alpha )
% function ll = lpdfDP( z , alpha )
% z is sample_count by table_count matrix, each sample has single one, rest
% zero. likelihood based on prop 3, antoniak 1974

% remove any zero (unused) columns
zero_ind = find( sum( z , 1 ) == 0 );
z( : , zero_ind ) = [];

% compute
n = size( z , 1 );
p = sum( z );
[ m v ] = freqTable( p );
k = length( p );
ll = gammaln( n + 1 ) + gammaln( alpha + 1 ) + k * gammaln( alpha ) ...
    - gammaln( alpha + n ) ...
    - sum( m .* log( v ) ) ...
    - sum( gammaln( m + 1 ) );

