function lp = lpdfExp( a , lambda )
% function lp = lpdfExp( a , lambda );
% computes the log probability density for a matrix with independent
% entries exponential with rate lambda
if any( any( a < 0 ) )
    lp = -Inf;
else
    lp = numel( a ) * log( lambda ) - ...
        lambda * sum( sum( a ) );
end