clear;

% --- create some data --- % 
x = rand( 100 , 10 );

% --- set the basic parameters --- %
% likelihood model/hyper parameters
param_set.model_type = 'exp';
param_set.lambda = .25; % rate for the exponential
param_set.sigma_n = 1; % variance for the noise

% prior parameters
param_set.alpha_c = 2; % category level
param_set.alpha_e = 2; % bottom level IBP
param_set.q = .5; % for the noisy-or

% whether to resample hyper parameters
param_set.resample_hyper_set = true;

% name to save the results
param_set.fname = 'un3';

% display settings
param_set.make_plots = false;

% inference settings
param_set.restart_count = 2;
param_set.iter_count = 5;

% how far back to look when computing the error
param_set.sample_window = 1;

% which inference algorithms to run
param_set.do_dp_ibp = 1;
param_set.do_ibp_ibp = 1;
param_set.do_category_ibp = 1;

% --- prepare plots --- %
if param_set.make_plots
    figure(2); clf;
    subplot( 1 , 3 , 1 ); 
    imagesc( x );
end

% --- run the tester --- %
tester( x , param_set )

